#!/usr/bin/env bash

# Benchmark info
echo "TIMING - Starting main script at: $(date) - launching CryoSPARC v<%= context.version %>"

#Note: something is interferring with the logging by truncating the output.log file sometime below this line.
#if the file is read very early the contents are visible but quickly disappear

# Set working directory to home directory
cd "${HOME}"

if [ "<%= context.version %>" == "3.3.1" -a -d $HOME/.cryosparc ]
then
  CRYOSPARC_DATA=.cryosparc
else
  CRYOSPARC_DATA=.cryosparc-<%= context.version %>
fi
CRYOSPARC_BIN=/opt/cryosparc/cryosparc_master/bin
CRYOSPARC_TMP=$(mktemp -d)
TMP_IN_CONTAINER=/tmp
S_IMAGE=/shared/software/singularity/images/cryosparc-<%= context.version %>.sif
S_OPTS="--no-mount tmp"
export CRYOSPARC_BASE_PORT=${port}
export CRYOSPARC_FORCE_USER=true
export CRYOSPARC_LICENSE_ID="<%= context.license %>"
export SINGULARITY_BINDPATH="$CRYOSPARC_TMP:/tmp,$HOME/$CRYOSPARC_DATA:/opt/data/cryosparc,$HOME/$CRYOSPARC_DATA/run:/opt/cryosparc/cryosparc_master/run,/shared/space2:/shared/space2"

mkdir -p $HOME/$CRYOSPARC_DATA/run

module load singularity

if [ \( "<%= context.version %>" == "4.0.3" -a -d $HOME/.cryosparc-4.0.3 \) -o \( "<%= context.version %>" == "4.2.1" -a -d $HOME/.cryosparc-4.2.1 \) ]
then
#sync the port allocated by OOD with what the database thinks it should be using
MONGOD_PORT=$(( CRYOSPARC_BASE_PORT + 1 ))
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/../deps/external/mongodb/bin/mongod --dbpath .cryosparc-<%= context.version %>/ --replSet meteor --port $MONGOD_PORT &
MONGODPID=$!
sleep 3
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/../deps/external/mongodb/bin/mongo --port $MONGOD_PORT --eval 'rs.config()' >$CRYOSPARC_TMP/conf.tmp
cat $CRYOSPARC_TMP/conf.tmp
echo -n "rs.reconfig(" >$CRYOSPARC_TMP/conf.new
tail -n +5 $CRYOSPARC_TMP/conf.tmp | sed -e 's/"host" : "localhost:[0-9]*",/"host" : "localhost:'$MONGOD_PORT'",/' >>$CRYOSPARC_TMP/conf.new
echo -n ',{"force":true});' >>$CRYOSPARC_TMP/conf.new
echo "-- NEW --"
cat $CRYOSPARC_TMP/conf.new
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/../deps/external/mongodb/bin/mongo --port $MONGOD_PORT /tmp/conf.new
sleep 1
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/../deps/external/mongodb/bin/mongo --port $MONGOD_PORT --eval 'rs.config()'
kill -TERM $MONGODPID

fi

singularity exec $S_IMAGE cat /opt/cryosparc/cryosparc_master/config.sh

# check if an instance is already running. This is probably useless since /tmp is isolated
# TODO: maybe try to re-use CRYOSPARC_TMP form the same user if it already exists so a running instance on a node might be detected.
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm status | grep "app *RUNNING * pid" && echo "A cryosparc master seems to be already running on this node" && exit 1

#experimental upgrade process #does not work because CS wants to dl stuff
#CRYOSPARC_VERSION_OF_DATA=$(cat $CRYOSPARC_DATA/cryosparc_version 2>/dev/null || ls $CRYOSPARC_DATA/collection* &>/dev/null && echo "3.3.1")
#if [ "$CRYOSPARC_VERSION_OF_DATA" != "" ]
#then
#  if [ "$CRYOSPARC_VERSION_OF_DATA" != "<%= context.version %>" ]
#  then
#    singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm update --version=v<%= context.license %> || exit 1
#  fi
#fi
#echo "<%= context.version %>" > $CRYOSPARC_DATA/cryosparc_version

#take care to remove only for current user
#find /tmp -name 'cryosparc-supervisor-*.sock'
#find /tmp -name 'cryosparc-supervisor-*.sock' -user $USER -exec rm '{}' ';'

mkfifo $CRYOSPARC_TMP/headsup

cat >$CRYOSPARC_TMP/cluster_info.json <<EOT
{
"qdel_cmd_tpl": "scancel {{ cluster_job_id }}",
"worker_bin_path": "/shared/software/singularity/wrappers/cryosparc-worker/<%= context.version %>/cryosparcw",
"title": "IGBMC",
"cache_path": "/scratch/cryosparc_cache",
"qdel_cmd_tpl": "$TMP_IN_CONTAINER/slurm_helper.sh scancel {{ cluster_job_id }}",
"qinfo_cmd_tpl": "$TMP_IN_CONTAINER/slurm_helper.sh sinfo --format='%.8N %.6D %.10P %.6T %.14C %.5c %.6z %.7m %.7G %.9d %20E'",
"qsub_cmd_tpl": "$TMP_IN_CONTAINER/slurm_helper.sh sbatch {{ script_path_abs }}",
"qstat_cmd_tpl": "$TMP_IN_CONTAINER/slurm_helper.sh squeue -j {{ cluster_job_id }}",
"cache_quota_mb": null,
"send_cmd_tpl": "{{ command }}",
"cache_reserve_mb": 10000,
"name": "IGBMC"
}
EOT

cat >$CRYOSPARC_TMP/cluster_script.sh <<EOT
#!/bin/bash
#SBATCH --account=<%= context.slurm_account %>
#SBATCH --job-name=CryoSPARC_{{ project_uid }}_{{ job_uid }}
#SBATCH --partition=<%= context.slurm_partition_worker %>
#SBATCH --output={{ job_log_path_abs }}
#SBATCH --error={{ job_log_path_abs }}
#SBATCH --nodes=1
#SBATCH --mem={{ (ram_gb*1000)|int }}M
#SBATCH --ntasks-per-node=1
#SBATCH --cpus-per-task={{ num_cpu }}
#SBATCH --gres=gpu:<% if context.gres_gpu != '' -%><%= context.gres_gpu %>:<% end %>{{ num_gpu }}
#SBATCH --time=<%= context.bc_num_hours %>:00:00
#$CRYOSPARC_TMP/cluster_script.sh

#added for 4.0.3
export CRYOSPARC_LICENSE_ID="$CRYOSPARC_LICENSE_ID"
export CRYOSPARC_MASTER_HOSTNAME="$HOSTNAME"
export CRYOSPARC_BASE_PORT=$CRYOSPARC_BASE_PORT

. /etc/profile.d/modules.sh
module load singularity

{{ run_cmd }}
EOT

#provide a way for the user to specify his/her own cluster script
if [ -f .cryosparc-<%= context.version %>/cluster_script.sh ]
then
  cp .cryosparc-<%= context.version %>/cluster_script.sh $CRYOSPARC_TMP/cluster_script.sh
fi

sed -i -e 's/export CRYOSPARC_MASTER_HOSTNAME=".*"/export CRYOSPARC_MASTER_HOSTNAME="'$HOSTNAME'"/g' $CRYOSPARC_TMP/cluster_script.sh
sed -i -e 's/export CRYOSPARC_BASE_PORT=.*/export CRYOSPARC_BASE_PORT='$CRYOSPARC_BASE_PORT'/g' $CRYOSPARC_TMP/cluster_script.sh

#Behold! Below is shell sorcery that is used to proxy a command run from within the container but will be executed outside.
#Indeed, the s* commands from Slurm are not available inside the container since we do not install a slurm client inside the container.
#It would be nonsensical to do so because it would prevent cluster software upgrades
#so s* commands must be run on the cluster node outside of the container. The following script writes the requested command to a shared place,
#and uses pipes to forward stdin,stdio and stderr. Once the command is terminated, the return code is passed along.
cat >$CRYOSPARC_TMP/slurm_helper.sh <<EOT
#!/bin/bash
COMMAND_TEMP=\$(mktemp -d -p $TMP_IN_CONTAINER)
#echo "\$*" "<\$COMMAND_TEMP/stdin >\$COMMAND_TEMP/stdout 2>\$COMMAND_TEMP/stderr ;" 'echo \$?' ">\$COMMAND_TEMP/retcode" >\$COMMAND_TEMP/command
echo "\$*" >\$COMMAND_TEMP/command
mkfifo \$COMMAND_TEMP/stdin
mkfifo \$COMMAND_TEMP/stdout
mkfifo \$COMMAND_TEMP/stderr
mkfifo \$COMMAND_TEMP/retcode
echo "." >$TMP_IN_CONTAINER/headsup

cat <\$COMMAND_TEMP/stderr >&2 &
cat <\$COMMAND_TEMP/stdout &
cat >\$COMMAND_TEMP/stdin &

ret=\$( cat \$COMMAND_TEMP/retcode )
kill %1 %2 %3
rm \$COMMAND_TEMP/stdin \$COMMAND_TEMP/stdout \$COMMAND_TEMP/stderr \$COMMAND_TEMP/retcode
#rmdir \$COMMAND_TEMP
exit \$ret
EOT

chmod +x $CRYOSPARC_TMP/slurm_helper.sh

DBPORT=OK
echo "test"

exec 3<&1
if singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm start 2>&1 | tee /dev/fd/3 | grep fixdbport
then
  echo "Automatically changing port in database"
  singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm fixdbport
  singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm restart
fi

echo "Tmp jail: $CRYOSPARC_TMP" --  CryoSPARC v<%= context.version %>

singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/../deps/external/mongodb/bin/mongo --port $(( CRYOSPARC_BASE_PORT + 1 )) --eval 'rs.config()'

singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm createuser --email "$USER@igbmc.fr" --password "${password}" --username $USER --firstname cryosparc --lastname cryosparc
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm resetpassword --email "$USER@igbmc.fr" --password "${password}"

## !!! This is WAAAY too bug-prone
cd $TMP_IN_CONTAINER
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm cluster connect

#so that the CMD loop below expands to nothing when there is no command
shopt -s nullglob


(
 #in that subshell we are going to run workers so re-define SINGULARITY_BINDPATH to the default to not interfere with /tmp mounts
 #We run a loop to gather the s* commands that CryoSPARC wants to execute and that are only available outside of the container.
 unset SINGULARITY_BINDPATH

 while true
 do
   read a <$CRYOSPARC_TMP/headsup
   for CMD in $CRYOSPARC_TMP/*/command
   do
     echo $CMD
     chmod +x $CMD
     mv $CMD $CMD.DONE #rename before exec to avoid race condition where execution below does not find file because it has been renamed
     $CMD.DONE <${CMD%command}stdin >${CMD%command}stdout 2>${CMD%command}stderr ; echo $? >${CMD%command}retcode &
   done
 done)&

while true
do
## BUG ! if another instance is created fast enough, it will pick it up and not exit
singularity exec $S_OPTS $S_IMAGE $CRYOSPARC_BIN/cryosparcm status | grep "not running" && break
sleep 20
#  for CMD in $CRYOSPARC_TMP/*/command
#  do
#     echo $CMD
#     chmod +x $CMD
#     mv $CMD $CMD.DONE #rename before exec to avoid race condition where execution below does not find file because it has been renamed
#     $CMD.DONE &
#  done
done

